<?php
/* -----------------------------------------------------------------------------
  Plugin     : Histogram
  Author     : Grum
    email    : grum@piwigo.org
    website  : http://photos.grum.fr

    << May the Little SpaceFrog be with you ! >>
  ------------------------------------------------------------------------------
  See main.inc.php for release information

  --------------------------------------------------------------------------- */


  define('PHPWG_ROOT_PATH',dirname(dirname(dirname(__FILE__))).'/');

  /*
   * set ajax module in admin mode if request is used for admin interface
   */
  if(!isset($_REQUEST['ajaxfct'])) $_REQUEST['ajaxfct']='';
  if(preg_match('/^admin\./i', $_REQUEST['ajaxfct'])) define('IN_ADMIN', true);
  if(!defined('AJAX_CALL')) define('AJAX_CALL', true);

  // the common.inc.php file loads all the main.inc.php plugins files
  include_once(PHPWG_ROOT_PATH.'include/common.inc.php' );
  include_once(PHPWG_PLUGINS_PATH.'GrumPluginClasses/classes/GPCAjax.class.inc.php');
  include_once('hgram_root.class.inc.php');

  load_language('plugin.lang', HGRAM_PATH);


  class HGram_ajax extends HGram_root
  {


    /**
     * constructor
     */
    public function __construct($prefixeTable, $filelocation)
    {
      parent::__construct($prefixeTable, $filelocation);
      $this->loadConfig();
      $this->checkRequest();
      $this->returnAjaxContent();
    }

    /**
     * check the $_REQUEST values and set default values
     *
     */
    protected function checkRequest()
    {
      global $user;

      // check if asked function is valid
      if(!(
           $_REQUEST[GPC_AJAX]=='public.histo.build'
          )
        ) $_REQUEST[GPC_AJAX]='';


      if(preg_match('/^admin\./i', $_REQUEST[GPC_AJAX]) and !is_admin()) $_REQUEST[GPC_AJAX]='';

      // check token validity - don't use GPCAjax::checkToken() because using an homemade token..
      if(!isset($_REQUEST['token'])) $_REQUEST['token']='';



      if($_REQUEST[GPC_AJAX]!='')
      {
        /*
         * check public.histo.build
         */
        if($_REQUEST[GPC_AJAX]=="public.histo.build")
        {
          if(!isset($_REQUEST['id'])) $_REQUEST[GPC_AJAX]='';
          if($_REQUEST['token']!=self::getToken($_REQUEST['id'])) $_REQUEST[GPC_AJAX]='';
        }
      }
    }


    /**
     * return ajax content
     */
    protected function returnAjaxContent()
    {
      $result="<p class='errors'>An error has occured</p>";
      switch($_REQUEST[GPC_AJAX])
      {
        case 'public.histo.build':
          $result=$this->ajax_hgram_public_histoBuild($_REQUEST['id']);
          break;
      }
      GPCAjax::returnResult($result);
    }


    /*------------------------------------------------------------------------*
     *
     * PUBLIC FUNCTIONS
     *
     *----------------------------------------------------------------------- */
    private function ajax_hgram_public_histoBuild($imageId)
    {
      return(self::getHistogramGraph($imageId, true));
    }



    /*------------------------------------------------------------------------*
     *
     * ADMIN FUNCTIONS
     *
     *----------------------------------------------------------------------- */



  } //class


  $returned=new HGram_ajax($prefixeTable, __FILE__);
?>
